/**
 *         pwncurl 0.1
 *      (c) 2009 by DracoBlue
 *
 * @author DracoBlue (DracoBlue.com)
 *
 * @version 0.1
 * @date 7th April 2009
 * @update 7th April 2009
 *
 * This file is provided as is (no warranties).
 *
 * It's released under the terms of MIT.
 * 
 * Feel free to use it, a little message in
 * about box is honouring thing, isn't it? *
 */

/*
 * Default Includes
 */
#include <stdio.h>
#include <stdlib.h>
#include <iostream>

/*
 * CURL Includes
 */
#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>

/*
 * AMX Includes
 */
#include "./AMX_SDK/amx/amx.h"
#include "./AMX_SDK/plugincommon.h"

extern void * pAMXFunctions;

using namespace std;  
   
// Write any errors in here  
static char errorBuffer[CURL_ERROR_SIZE];  
   
// Write all expected data in here  
static string buffer;  
   
// This is the writer call back function used by curl  
static int writer(char *data, size_t size, size_t nmemb,  
                   std::string *buffer)  
{  
    // What we will return  
    int result = 0;  
   
    // Is there anything in the buffer?  
    if (buffer != NULL)  
    {  
        // Append the data to the buffer  
        buffer->append(data, size * nmemb);  
   
        // How much did we write?  
        result = size * nmemb;  
    }  
   
    return result;  
}  

PLUGIN_EXPORT unsigned int PLUGIN_CALL Supports() 
{
    return SUPPORTS_VERSION | SUPPORTS_AMX_NATIVES;
}

PLUGIN_EXPORT bool PLUGIN_CALL Load( void **ppData ) 
{
    pAMXFunctions = ppData[PLUGIN_DATA_AMX_EXPORTS];
    cout << "    pwncurl loaded. (c) 2009 by DracoBlue";
    return true;
}

PLUGIN_EXPORT void PLUGIN_CALL Unload( )
{
    cout << "    pwncurl unloaded. (c) 2009 by DracoBlue";
}

// native pwnurl_get(url[],buf[],buflen);
static cell AMX_NATIVE_CALL n_pwncurl_get( AMX* amx, cell* params )
{
    if(params[0] != 12)
    {
        return -3;
    }

    char * url;
    amx_StrParam(amx,params[1],url);
    char * buf;
    int buflen = params[3];
    
    buf = new char[buflen + 1];
    
    CURL *curl;  
    CURLcode result;  
   
    curl = curl_easy_init();  
   
    if (curl)  
    {  
    buffer.clear();
    curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, errorBuffer);  
    curl_easy_setopt(curl, CURLOPT_URL, url);  
    curl_easy_setopt(curl, CURLOPT_HEADER, 0);  
    curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1);  
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writer);  
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);  
   
        result = curl_easy_perform(curl);  
   
    curl_easy_cleanup(curl);  
   
        if (result == CURLE_OK)  
        {  
        cell *dest;
        amx_GetAddr(amx,params[2],&dest);
        amx_SetString(dest,buffer.data(),0,0,buflen + 1);
        return buffer.size();
    }  
    else  
    {  
        cout << "Error: [" << result << "] - " << errorBuffer;  
        return -1; 
        }  
    }  
    return -2;
}

AMX_NATIVE_INFO pawncurlAMXNatives[ ] =
{
    {"pwncurl_get",  n_pwncurl_get},
    {0,                0}
};

PLUGIN_EXPORT int PLUGIN_CALL AmxLoad( AMX *amx ) 
{
    return amx_Register( amx, pawncurlAMXNatives, -1 );
}

PLUGIN_EXPORT int PLUGIN_CALL AmxUnload( AMX *amx ) 
{
    return AMX_ERR_NONE;
}
